Conjuring lets you convert excel files into a database.
Then it lets you serve it up!  I intend for it to make it easy to serve up 
excel files as database objects on [Webfaction](http://www.webfaction.com?affiliate=lucidguppy).

Authentication
--------------
Conjuring will use [Mozilla Persona](http://www.mozilla.org/en-US/persona/) to 
log you in.  If you have a "users" table in the excel file - it will check
that the persona account is in that table.

Formatting your Excel File For Conversion
-----------------------------------------
Here's an example list of column headers

* id	<-- make sure this is integer and progressing and unique
* part_number.text.unique	
* description.text	
* price.int	 <-- right now prices are integer pennies
* count.int	
* top_speed.float	
* date_added.date

Notes:
1.  Dates should be in the date format for excel.
2.  In the spreadsheet the price is in pennies.  The database will work with 
    price and costs in pennies.

Creating SQLite Databases from Excel Files
------------------------------------------
	import conjuring.creation as creation

	if __name__ == "__main__":
	    creation.xlsx_to_sqlite("dummy.xlsx")

Serving up SQLite Databases
---------------------------
	from conjuring.presentation import present

	app = present('sqlite:///dummy.db', 'localhost')
	app.config.from_object('config')
	app.run(debug=False)
