from sqlalchemy import or_, and_
from datetime import date


def add_varchar_filtered_columns(filtered_columns, col, args):
    arg = col.name
    if args[arg] == "":
        return filtered_columns
    else:
        filtered_columns.append(col.name)
    return filtered_columns


def varchar_filter(table, col, args):
    arg = col.name
    if args[arg] == "":
        return None
    this_clause = None
    string_arg = str(args[arg])
    this_group = [getattr(table.c, col.name).startswith('%s' % (string_arg)),
                  getattr(table.c, col.name).ilike('%%%s%%' % (string_arg)),
                  getattr(table.c, col.name).endswith('%s' % (string_arg))]
    this_clause = or_(*this_group)
    return this_clause


def add_integer_filtered_columns(filtered_columns, col, args):
    for arg in ["%s%s" % (test, col.name) for test in ['eq', 'gt', 'lt']]:
        if args[arg] == "":
            continue
        else:
            filtered_columns.append(col.name)
    return filtered_columns


def integer_filter(table, col, args):
    this_group = []
    this_clause = None
    for arg in ["%s%s" % (test, col.name) for test in ['eq', 'gt', 'lt']]:
        if args[arg] == "":
            continue
        if arg[:2] == "eq":
            this_group.append(getattr(table.c, col.name) == int(args[arg]))
        elif arg[:2] == "lt":
            this_group.append(getattr(table.c, col.name) < int(args[arg]))
        elif arg[:2] == "gt":
            this_group.append(getattr(table.c, col.name) > int(args[arg]))
    if this_group != []:
        this_clause = and_(*this_group)
    return this_clause


def add_float_filtered_columns(filtered_columns, col, args):
    for arg in ["%s%s" % (test, col.name) for test in ['eq', 'gt', 'lt']]:
        if args[arg] == "":
            continue
        else:
            filtered_columns.append(col.name)
    return filtered_columns


def float_filter(table, col, args):
    this_group = []
    this_clause = None
    for arg in ["%s%s" % (test, col.name) for test in ['eq', 'gt', 'lt']]:
        if args[arg] == "":
            continue
        if arg[:2] == "lt":
            this_group.append(getattr(table.c, col.name) < float(args[arg]))
        if arg[:2] == "gt":
            this_group.append(getattr(table.c, col.name) > float(args[arg]))
    if this_group != []:
        this_clause = and_(*this_group)
    return this_clause


def add_date_filtered_columns(filtered_columns, col, args):
    for arg in ["%s%s" % (test, col.name) for test in ['eq', 'gt', 'lt']]:
        if args[arg] == "":
            continue
        else:
            filtered_columns.append(col.name)
    return filtered_columns


def date_filter(table, col, args):
    this_group = []
    this_clause = None
    for arg in ["%s%s" % (test, col.name) for test in ['eq', 'gt', 'lt']]:
        if args[arg] == "":
            continue
        mo, day, year = args[arg].split("/")
        print(year, mo, day)
        d = date(int(year), int(mo), int(day))
        if arg[:2] == "eq":
            this_group.append(getattr(table.c, col.name) == d)
        elif arg[:2] == "lt":
            this_group.append(getattr(table.c, col.name) < d)
        elif arg[:2] == "gt":
            this_group.append(getattr(table.c, col.name) > d)
    if this_group != []:
        this_clause = and_(*this_group)
    return this_clause
